# Plugins "BGSketchup_Comments" created by BGSketchup (Inteloide)
#
# Show a window with text aera to add comments, history, etc... Texts are saved in .SKP file
#
# Permission to use, copy, modify, and distribute this software for any purpose, and currently without fee, is hereby granted, 
# provided that this text and the above copyright (c) notice appear in all copies.
# This software is provided "as is" and without any express or implied warranties, including, without limitation, the implied 
# warranties of merchantability and fitness for a particular purpose.

# Plugin "Comments" created par BGSketchup (Inteloide)

module BGSketchup_Comments
	#Required libraries
		require "sketchup.rb"
		require "extensions.rb"
	#Extension data
		BGSketchup_Comments_extension = SketchupExtension.new "BGSketchup_Comments", "BGSketchup_Comments/Comments"
		BGSketchup_Comments_extension.version = 'v2.3.10'
		BGSketchup_Comments_extension.copyright = 'BGSketchup, October 2014'
		BGSketchup_Comments_extension.creator = 'BGSketchup (Inteloide)'
		BGSketchup_Comments_extension.description = "Add comments to a file"
		Required_library_version=2*10000+5*100+6
		Sketchup.register_extension(BGSketchup_Comments_extension, true)
end

=begin
Ckeditor plugins:
	- Font Size and Family
	- Image browse
	Modifications in ckeditor :
	- modification of config.js : removed underline from line config.removeButtons = 'Underline,Subscript,Superscript';
	- modification of content.css : body { margin: 0px;}

Version history:
	2.3.10	Optimized : Add more space between tab name and icon to delete or modify tab
			Optimized :	Added pt-br language (thanks to greenskp) 
			
	2.3.9	Corrected : BGSketchup Library not found if not in standard plugin folder
	
	2.3.8	Corrected :	Error in ruby when cancel tab creation
			This version require BGSketchup_Library 2.3.2
	
	2.3.7	Optimized : Added chinese languages.
	
	2.3.6:	Updated : 	version of ckeditor update to 4.4.5
			Added :		Change tab key behavior to add spaces (4)
			Corrected : enter key now make a simple return to line
			
	2.3.5:	Corrected :	Plugin window remain at same position  each time you close it
			Optimized : Open updater instead of weblink to upload latest version of Library
			This version require BGSketchup_Library 2.0.7
	
	2.3.4:	Corrected : Avoid errors with jquery.
	
	2.3.3:	Corrected :	Comments not saved when closing window without change tab
			Corrected :	Error when changing language
			Optimized : better management of BGSketchup_Library
			This version of plugin require BGSketchup_Library 2.0.5
	
	2.3.2:	Corrected : Tab color feature works again
			Optimized :	Plugins update checking on start
			This version of plugin require BGSketchup_Library 2.0.0
			
	2.3.1:	Corrected :	Issue with usage counter increase
			This version of plugin require BGSketchup_Library 2.0.0
	
	2.3.0:	Corrected : avoid asking for saving when model is just opened
			Optimized :	use of new BGSketchup_Library strategy
			Optimized :	Group menus with other BGSketchup plugins
			Optimized :	Introduction of statistics
			
	2.2.2:	Corrected :	Tab text scratch when closing and re-openning the window.
			Corrected :	Avoid having tab text in grey when close and re-openning window
			Corrected : Issue when deleting tabs corrected
			Optimized :	Update checking modify to avoid prompt if computer version is newer than official web version (for development purpose)
	
	2.2.1:	Corrected :	Error could appear when changing tabs
	
	2.2.0:	Added :		Allow following hyperlink, open a new brownser windows with link opened. Check options !
			Optimized :	Categorized options
	
	2.1.0:	Added :		Update checking ! To be sure to have the latest version of the plugin !
			Added :		Change button icon to a menu.
			PS : Note that plugin try to load an external javascript code from http://bgsketchup.esy.es. This code allow the plugin to check the latest version. No information is transfered to the website. The script only send to Sketchup the latest version.
	
	2.0.0:	Added :		Change text editor to CKEditor, to add possibilty to have rich text format
			Added :		Function to add calculator formula and result in the text area
			Added :		Options to close or not the calculator after result inserting
			Removed :	Option to show bottom of content (could not program it with CKEditor)
			Corrected :	Missing tab action button translation for last tab.
			Optimized :	Change action buttons size
			
	
	1.7.1:	Optimized :	Change actions calculator's buttons format
	
	1.7.0:	Added :		Calculator feature added (http://www.supportduweb.com/scripts_tutoriaux-code-source-12-calculatrice-en-javascript-avec-bouttons.html)
			Added :		Rounded corner for tabs
			Modified :	Selecting and mouse over colors
			Optimized :	Improve tab color display
			Optimized :	Optimize CSS code
			Corrected : Small bug in tab scrolling when resizing the window
	
	1.6.2:	Corrected :	removed console show
	
	1.6.1:	Corrected :	Glro bug when deleting a tab
			Optimized :	Added translation of tab color text
			
	1.6.0:	Added :		Tab color feature added.
	
	1.5.5:	Optimized:	Added some code to detect where a javascript error comes from.
	
	1.5.4:	Optimized:	Text is not save each time a key is pressed, this in order to have the text area more reactive
			Optimized:	Changed windows size for user who use the plugin for the first time (next time, the plugin remains windows sizes)
			Added :		Russian translation (thanks alexanor)

	1.5.3:	Corrected :	Tab link doesn't if window was not automatically opened (through options)
			Corrected :	Tabs in windows remain from previous model if user choose File/New
			
	1.5.2:	Corrected : Error when closing and opening again the window, or change the language.
	
	1.5.1:	Corrected :	Bugs when deleting a tab in the model
			Corrected :	Translation issue in tab option and deletion button titles
			Optimized :	 Request user to write plugin version when sending a bug.
	
	1.5.0:	Added :		Copyright and warranties texts in about window, and other things.
			Corrected : Avoid SU to ask for saving if nothing was changed in Comments window
			Corrected : First tab name use translation of 'Tab 1'
			Optimized :	Create observers only if required
			Optimized :	Fix font size in tab slider to avoid issue due to browser differences
			Optimized : Added translation possibility
			Optimized : Add border around slider button (when window is resized smaller than tabs width)
			Optimized :	Reduce code size
			
	1.4.0:	Added :		Possibility to link a tab to a scene
			Corrected :	Issue that could appear with accented names

	1.3.1:	Corrected :	Allow the modification of tab name on first tab
			Corrected : Allow special characters in tab name
			Corrected : Remove prompt when deleting a tab
			Corrected : Hide tabs when showing options
			Optimized :	Add translation possibility for last adding feature
			Optimized :	Increase tab "+" size for more accessibility
			Optimized :	Add border around tab for to distinguish tabs more easily
	
	1.3.0:	Added :		Rename function (new icon on tab)

	1.2.1:	Corrected : Avoid error when deleting tab placed before current tab	

	1.2.0:	Added :		Added possibility to have different tabs
			Optimzed :	Change toolbar name to "Comments (BGSketchup)"
			Optimzed :	Avoid filling "undo" stack with comments saving operation.

	1.1.1:	Optimized :	Change extension name
	
	1.1.0:	Added : 	Link to the forum page
			Added :		German translation (thanks to Aerilius)
			Corrected :	Change windows HTML link to relative, in case plugin is not in standard folder. (Thx Aerilius)
			Corrected :	Add code to prevent error when using special characters.
			Corrected :	Improved saving system, in order to prevent from text modification lose when closing the skp file
			Optimized : Change some code to have plugin more stable. (Thx Aerilius)
			Optimized :	Use of user default backcolor window instead of white. (Thx Aerilius)

	1.0.0:	First Official Release in SketchUcation
	
	1:		First release (31/12/2012), only published on http://rhin.crai.archi.fr/rld/plugin_details.php?id=1031 as "History"
=end