# Plugin "Comments" created par BGSketchup (Inteloide)

module BGSketchup_Comments
	class Comments
		Sketchup::require 'BGSketchup_Comments/Localization'
		extend BGSketchup_Comments
		
		@current_tab=0
		@old_current_tab=0
		@number_of_tab=1
		@work_in_progress=false
		
		def self.show_hide_Comments_window
			#On affiche la fentre
				if @my_dialog==nil 
					# On cr la bote de dialogue    
						@my_dialog = UI::WebDialog.new(@strWindowName+" "+BGSketchup_Comments_extension.version, false, "BGSketchup_Comments" , 300, 320, 200, 200, true)
					# On affiche la bote de dialogue
						html_path = File.join(File.dirname(__FILE__), "Html", "Comments.html")#"Une boite a coins arrondis en CSS3.htm")#"Comments.html")#
						@my_dialog.set_file(html_path)
						@my_dialog.show()
						@my_dialog.set_background_color(@my_dialog.get_default_dialog_color)
						self.load_options_in_html
						@my_dialog.set_on_close {
							self.save_comments
						}
						
						
					# Gestion des actions gnres par la bote de dialogue
						@my_dialog.add_action_callback("get_data") do |web_dialog,action_name|
							if action_name.index("(")!=nil then
								action=action_name[0..action_name.index("(")-1]
								parameter=action_name[action.length+1..action_name.length-2].split(",")
								action_name=action
							end
							case action_name
								when "save_comments" then self.set_flag_CommentsToBeSaved #self.save_comments
								when "translation" then self.translation
								when "about" then self.about 
								when "load_options" then self.load_options_in_html
								when "start" then self.start
								when "show_tab" then self.show_tab(parameter[0].to_i)
								when "add_tab" then self.add_tab(parameter[0])
								when "delete_tab" then self.delete_tab(parameter[0].to_i)
								when "modify_tab" then self.show_tab_options(parameter[0].to_i) #self.modify_tab(parameter[0].to_i)
								when "appliquerOptions" then self.appliquerOptions(parameter[0])
								when "result_in_VCB" then self.result_in_VCB(parameter[0])
								when "check_for_updates" then self.check_for_updates(parameter[0])
								when "prompt_update_check" then self.prompt_update_check(parameter[0],parameter[1])
								when "bgSketchup_erreur_script" then bgSketchup_erreur_script(parameter)
							end
						end
				else #Si la fentre est dj affiche
					if @my_dialog.visible? ==false then
						@my_dialog.show()
					else
						@my_dialog.close()
					end
				end      
		end # def
		
		#LOAD/SAVE COMMENTS
		def self.load_comments(tab=0)			# Load comment of tab "tab"
			#Load default tab if necessary
				tab='' if (tab==0)
			#Get Comments in Model
				model = Sketchup.active_model 
				value = model.get_attribute "BGSketchup_Comments", "Text"+tab.to_s, ""
			#Update if window exist or options for auto-openning are ok
				if (@my_dialog==nil && (@option_open_window==true || (@option_open_window_if_exist==true && value!="")))
					self.show_hide_Comments_window
					return nil #If window is created, the javascript will call 'start' procedure : no need to continue
				end
				return nil if @my_dialog==nil
			#Load the Comments
				js ="m=true;"							#Prevent from saving 
				js+="bgSketchup_error='load_comments, tab="+tab.to_s+"';"
				js+= "loadComments('"+ bgSketchup_to_java(value) + "');"
				#js+= "editor.scrollIntoView;" if @option_show_bottom==true #marche pas
				#js+= "document.getElementById('comments').scrollTop=document.getElementById('comments').scrollHeight;" if @option_show_bottom==true
				js+= "current_text=editor.getData();"
				bgSketchup_execute_script(@my_dialog,js)
				bgSketchup_execute_script(@my_dialog,"m=false;")	#Authorize saving
		end
		def self.set_flag_CommentsToBeSaved 	# Set saving flag; triggered only by HTML page
			Sketchup.active_model.set_attribute "BGSketchup_Comments", "CommentsToBeSave", "true"
		end
		def self.save_comments 					# Save comments of current tab
			if @work_in_progress==false then
				#Get the text
					#nom=@my_dialog.get_element_value('comments')
					js ="bgSketchup_error='save_comments';"
					js ="document.getElementById('comments2').value=editor.getData();"
					bgSketchup_execute_script(@my_dialog,js)
					nom=@my_dialog.get_element_value('comments2')
				#Convert feed line
					nom=nom.gsub(10.chr, "").gsub(13.chr,"")
				#Save into Model attributes
					model = Sketchup.active_model
					tab=@current_tab; tab='' if tab==0
					if get_tab_text(@current_tab)!=nom then
						Sketchup.active_model.start_operation("Comment modification",false,false,true)
							value = model.set_attribute "BGSketchup_Comments", "Text"+tab.to_s, nom
							save_current_tab
						Sketchup.active_model.commit_operation
					end
			end
		end
		def self.save_current_tab 				# Save which is the current tab, in model attributes
			if @current_tab!=@old_current_tab then
				Sketchup.active_model.set_attribute "BGSketchup_Comments", "CurrentTab",@current_tab
				if (get_tab_name(0)=="" && get_tab_text(0)!="") then
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName", @strTab+'1'
				end
			end
		end
		
		def self.start 					#Load tabs, comments, options etc...
			self.load_tabs 			# Get the different tabs
			self.translation
			self.load_options_in_html
			@work_in_progress=true
			self.show_tab(Sketchup.active_model.get_attribute "BGSketchup_Comments", "CurrentTab",0);
			@work_in_progress=false
			self.attach_observers
			self.check_for_updates("check"); #Check for update and display a message if required
			@option_usage+=1
			self.save_options
			self.stats_incrementer_compteur
			bgSketchup_execute_script(@my_dialog,"setWindowSize();")
			bgSketchup_execute_script(@my_dialog,"plugin_version='"+BGSketchup_Comments_extension.version.to_s+"';")
		end
		
		# TABS
		def self.delete_tabs					#Delete all previous tabs if exist
			if @number_of_tab!=1 then
				js="bgSketchup_error='load_tabs-delete tab';"
				for i in 1..@number_of_tab-1
					js+="delete_Tab(1);"
				end
				bgSketchup_execute_script(@my_dialog,js)
			end
		end
		def self.load_tabs 						#Load and add tab from the Model into the window
			#Delete previous tabs if exist
				self.delete_tabs
				
			#Load the new ones
				@number_of_tab=1
				attrdict = Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments']
				if attrdict!=nil then
					#Get maximum number of tab
						max=0
						attrdict.each_key { | key |
							if key[0..3]="Text" then
								if key!="Text" then					
									ind=key[4..key.length-1].to_i
									if (ind>max) then
										max = ind
									end
								end
							end
						}
					#Load tabs, one by one
						for tab in 0..max
							tab2=tab; tab2='' if tab==0
							name=Sketchup.active_model.get_attribute "BGSketchup_Comments", "TabName"+tab2.to_s, @strTab+'1'
							if tab==0 then 			#Change first tab name
								js ="bgSketchup_error='load_tabs-tab0 name';"
								js+="document.getElementById('tabText0').innerHTML='"+bgSketchup_to_java(name)+"';" if (name!=nil)
								js+="document.getElementById('tabText0').style.background='"+get_tab_color(tab).to_s+"';"
								bgSketchup_execute_script(@my_dialog,js)
							else
								if (name!=nil) then	#Add a new tab in window
									js ="bgSketchup_error='load_tabs-tab"+tab.to_s+" add_tab';"
									js+="add_tab('"+bgSketchup_to_java(name)+"',false,'"+get_tab_color(tab).to_s+"');"
									#Change titles
									js+="bgSketchup_error='load_tabs-tab"+(@number_of_tab).to_s+" change title';"
									js+="document.getElementById('modifyTab"+(@number_of_tab).to_s+"').title='"+bgSketchup_to_java(@strModifyTabName)+"';"
									js+="document.getElementById('deleteTab"+(@number_of_tab).to_s+"').title='"+bgSketchup_to_java(@strDeleteTab)+"';"
									bgSketchup_execute_script(@my_dialog,js)
									@number_of_tab+=1
								end
							end
						end
				else #No attribute exist, we create the standard one
					bgSketchup_execute_script(@my_dialog,"document.getElementById('tabText0').innerHTML='"+bgSketchup_to_java(@strTab+'1')+"';")
				end
		end
		def self.show_tab(tab)					#Show tab "tab" in html window
			#Save comments of previous tab
				save_comments if (@work_in_progress==false) # if @current_tab!=tab

			#Save click tab as new current tab
				@old_current_tab=@current_tab
				@current_tab=tab
				self.save_current_tab
			
			#Load comments of clicked tab
				self.load_comments(tab)
			
			#Graphically select tab 
				bgSketchup_execute_script(@my_dialog,"select_tab("+tab.to_s+");") #Select tab in window
			
			#Show linked scene
				self.show_scene_linked_to_tab(tab)
		end
		def self.show_scene_linked_to_tab(tab) 	#Show scene linked to tab
			if @option_show_scene_when_tab_selected==true then
				scene=self.get_tab_scene(tab)
				if scene!="" then
					pages=Sketchup.active_model.pages
					for p in pages
						pages.selected_page=p if p.name==scene
					end
				end
			end
		end		
		def self.add_tab(number_of_tab)			#Add a new tab
			name=UI.inputbox([@strTabName],[@strTab+((number_of_tab.to_i+1).to_s)],@strTabName)
			if name!=false then
				bgSketchup_execute_script(@my_dialog,"add_tab('"+bgSketchup_to_java(name[0])+"');") if (name!=nil)
				Sketchup.active_model.start_operation("Comment modification",false,false,true)
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName"+number_of_tab.to_s, name[0]
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "Text"+number_of_tab.to_s, ""
				Sketchup.active_model.commit_operation
				bgSketchup_execute_script(@my_dialog,"show_tab(document.getElementById('tabText"+(@number_of_tab).to_s+"'));")
				#Change titles
					bgSketchup_execute_script(@my_dialog,"document.getElementById('modifyTab"+(@number_of_tab).to_s+"').title='"+bgSketchup_to_java(@strModifyTabName)+"';")
					bgSketchup_execute_script(@my_dialog,"document.getElementById('deleteTab"+(@number_of_tab).to_s+"').title='"+bgSketchup_to_java(@strDeleteTab)+"';")
				@number_of_tab+=1
			end
		end
		def self.delete_tab(tab)				#Delete tab "tab"
			#Confirmation
				reponse=UI.messagebox @strSureToDeleteTab, MB_YESNO
			#If Yes
				if reponse==6 then
					@work_in_progress=true
					#Deletion in attibutes
						Sketchup.active_model.start_operation("Comment modification",false,false,true)
							#Slice all tabs
								for j in tab..@number_of_tab-1
									i=j; i='' if j==0 #For first tab that is "Text" and not "Text0"
									Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName"+i.to_s, get_tab_name(j+1)
									Sketchup.active_model.set_attribute "BGSketchup_Comments", "Text"+i.to_s, get_tab_text(j+1)
									Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabScene"+i.to_s, get_tab_scene(j+1)
								end						
							#Delete last tab
								Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments'].delete_key("TabName"+(@number_of_tab-1).to_s)
								Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments'].delete_key("Text"+(@number_of_tab-1).to_s)
								Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments'].delete_key("TabScene"+(@number_of_tab-1).to_s)
								@number_of_tab-=1
						Sketchup.active_model.commit_operation
					
					#Graphical deletion in javascript
						bgSketchup_execute_script(@my_dialog,"delete_Tab("+tab.to_s+");")

					#Load new current tab comments
						if tab<=@current_tab then
							@current_tab-=1;
							@current_tab=0 if (@current_tab==-1)
							@current_tab=@number_of_tab-1 if (@current_tab>@number_of_tab-1)
							self.save_current_tab
							bgSketchup_execute_script(@my_dialog,"m=true;")
							bgSketchup_execute_script(@my_dialog,"show_tab(document.getElementById('tabText"+@current_tab.to_s+"'));")#("select_tab("+@current_tab.to_s+");")#
							bgSketchup_execute_script(@my_dialog,"m=false;")
						end
					@work_in_progress=false
				end
		end
		def self.get_tab_name(tab)
			tab='' if tab==0
			return Sketchup.active_model.get_attribute"BGSketchup_Comments", "TabName"+tab.to_s, ""
		end
		def self.get_tab_text(tab)
			tab='' if tab==0
			return Sketchup.active_model.get_attribute"BGSketchup_Comments", "Text"+tab.to_s, ""
		end
		def self.get_tab_scene(tab)
			tab='' if tab==0
			return Sketchup.active_model.get_attribute"BGSketchup_Comments", "TabScene"+tab.to_s, ""
		end
		def self.get_tab_color(tab)
			tab='' if tab==0
			return Sketchup.active_model.get_attribute"BGSketchup_Comments", "TabColor"+tab.to_s, "transparent"
		end
		def self.show_tab_options(tab)
			# On cr la bote de dialogue    
				dialog = UI::WebDialog.new(@strTabOptionName, false, "BGSketchup_Comments_Tab_Options" , 300, 250, 200, 200, true)
			# On affiche la bote de dialogue
				html_path = File.join(File.dirname(__FILE__), "Html", "Tab_options.html")
				dialog.set_file(html_path)
				dialog.set_background_color(dialog.get_default_dialog_color)
				tab2=tab;tab="" if (tab==0)
				dialog.add_action_callback("get_data") do |web_dialog,action_name|
					if action_name=="start" then
						js ="bgSketchup_error='show_tab_options, tab="+tab.to_s+"';"
						# Set current tab name & color
							if get_tab_name(tab)=="" then #If no name => we create a standard one.
								js+="document.getElementById('tabName').value='"+@strTab+"1';"
							else
								js+="document.getElementById('tabName').value='"+bgSketchup_to_java(get_tab_name(tab))+"';"
							end
							js+="document.getElementById('tabColor').value='"+get_tab_color(tab).to_s+"';"
							js+="document.getElementById('tabColor').style.background='"+get_tab_color(tab).to_s+"';"
								
						# Add the scene names
							js+="select = document.getElementById('selectTabList');"
							js+="select.options[0] = new Option('"+bgSketchup_to_java(@strNoLink)+"', '-1');"
							pages=Sketchup.active_model.pages
							for i in 0..pages.count-1
								js+="select.options["+(i+1).to_s+"] = new Option('"+bgSketchup_to_java(pages[i].name)+"', '"+i.to_s+"');"
							end
						# Select the correct scene
							scene = Sketchup.active_model.get_attribute "BGSketchup_Comments", "TabScene"+tab.to_s, ""
							if scene!="" then
								for i in 0..pages.count-1
									if pages[i].name==scene then
										js+="select.value='"+i.to_s+"';"
									end
								end
							end
						# Translate the texts
							for i in 0..@strTextsOptionsTab.length-1
								js+="document.getElementById('txt"+i.to_s+"').innerHTML='"+bgSketchup_to_java(@strTextsOptionsTab[i])+"';"
							end
						# Execute
							dialog.execute_script(js)
					elsif action_name=="Cancel" then
						dialog.close;
					elsif action_name=="Apply" then
						#Save the tab name & color
							name=dialog.get_element_value("tabName")
							Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName"+tab.to_s, name
							color=dialog.get_element_value("tabColor")
							Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabColor"+tab.to_s, color
							js ="bgSketchup_error='Apply options';"
							js+="document.getElementById('tabText"+tab2.to_s+"').innerHTML='"+bgSketchup_to_java(name)+"';"
							js+="document.getElementById('tabText"+tab2.to_s+"').style.background='"+color+"';"
							bgSketchup_execute_script(@my_dialog,js)
						#Save linked scene
							scene=dialog.get_element_value("selectTabList")
							if scene.to_s!="-1" then
								Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabScene"+tab.to_s, Sketchup.active_model.pages[scene.to_i].name
							else
								Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabScene"+tab.to_s, ""
							end
						#Close the window
							dialog.close;
					end
				end
				dialog.show_modal
		end
		
		# CALCULATOR
		def self.result_in_VCB(parameter)
			Sketchup.vcb_value=parameter
		end		
		def self.about					#Display "About" window
			wAbout = UI::WebDialog.new(@strAbout, false,"BGSketchup_Comments_About" , 316, 293, 100, 200, false)
			html_path = File.join(File.dirname(__FILE__), "Html", "about.html")#"About.html")
			wAbout.set_file(html_path)
			wAbout.set_background_color("ffffff")
			wAbout.set_size(400,320)
			wAbout.show_modal { wAbout.execute_script("document.getElementById('version').innerHTML='"+BGSketchup_Comments_extension.version+"';")}
		end	
		def self.creation_menus			#Add Plugins menu and toolbar
			menu=BGSketchup_Ajouter_Submenu("BGSketchup")
			menu.add_item(@strWindowName) {self.show_hide_Comments_window }
		end
		def self.creation_toolbar
			bgSketchup_creer_toolbar(@strWindowName,"BGSketchup_Comments::Comments.show_hide_Comments_window","BGSketchup_Comments/Html/Pictures/Comments-icon.png","BGSketchup_Comments/Html/Pictures/Comments-icon.png",@strWindowName,@strWindowName,@strWindowName)
		end
		def self.translation			#Translate texts in window
			if @my_dialog!=nil then
				js = "bgSketchup_error='translation';"
				js+= "liste=document.getElementById('languagelist');"
				js+= "liste.length=0;"
				for i in 0..@availableLanguages.length-1
					js+= "liste.options[liste.length] = new Option('"+@availableLanguagesName[i].to_s+"', '"+@availableLanguages[i].to_s+"');"+13.chr
				end
				for i in 0..@strButtonsTitles.length-1
					js+= "document.getElementById('Btn"+i.to_s+"').title='"+bgSketchup_to_java(@strButtonsTitles[i])+"';"+13.chr
				end
				for i in 0..@strButtonsTexts.length-1
					js+= "document.getElementById('BtnTxt"+i.to_s+"').innerHTML='"+bgSketchup_to_java(@strButtonsTexts[i])+"';"+13.chr
				end
				for i in 0..@strTexts.length-1
					js+= "document.getElementById('txt"+i.to_s+"').innerHTML='"+bgSketchup_to_java(@strTexts[i])+"';"+13.chr
				end
				for i in 0..@strLegends.length-1
					js+= "document.getElementById('leg"+i.to_s+"').innerHTML='"+bgSketchup_to_java(@strLegends[i])+"';"+13.chr
				end
				js+="document.getElementById('modifyTab0').title='"+bgSketchup_to_java(@strModifyTabName)+"';"
				js+="document.getElementById('deleteTab0').title='"+bgSketchup_to_java(@strDeleteTab)+"';"
				js+="document.getElementById('update_text').innerHTML='"+bgSketchup_to_java(@strVersionDifferent)+"';"
				bgSketchup_execute_script(@my_dialog,js)
			end
		end

		# OPTIONS
		def self.save_options
			file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Comments.ini")
			File.delete(file_name) if File.exists?(file_name)
			file=File.new(file_name, "w")
			file.puts("option_open_window") 
			file.puts(@option_open_window)
			file.puts("option_open_window_if_exist") 
			file.puts(@option_open_window_if_exist)
			file.puts("option_langue") 
			file.puts(@option_langue)
			file.puts("option_show_bottom") 
			file.puts(@option_show_bottom)
			file.puts("option_close_calc") 
			file.puts(@option_close_calc)
			file.puts("option_show_scene_when_tab_selected") 
			file.puts(@option_show_scene_when_tab_selected)
			file.puts("option_check_for_updates") 
			file.puts(@option_check_for_updates)
			file.puts("option_dblclick_for_link") 
			file.puts(@option_dblclick_for_link)
			file.puts("option_ctrl_for_link") 
			file.puts(@option_ctrl_for_link)
			file.puts("option_usage") 
			file.puts(@option_usage)
			file.close
		end
		def self.load_options
			#Load default option in case one option is missing
			self.load_default_options
			file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Comments.ini")
			if File.exists?(file_name)==true then 	#File exist
				file = File.open(file_name, "r")
				while !file.eof?
					option_name=file.readline.gsub(10.chr,"").gsub(13.chr,"")
					option_value=file.readline.gsub(10.chr,"").gsub(13.chr,"")

					@option_langue=option_value if option_name=="option_langue"
					@option_open_window=(option_value=="true") ? true : false if option_name=="option_open_window"
					@option_open_window_if_exist=(option_value=="true") ? true : false if option_name=="option_open_window_if_exist"
					@option_show_bottom=(option_value=="true") ? true : false if option_name=="option_show_bottom"
					@option_close_calc=(option_value=="true") ? true : false if option_name=="option_close_calc"
					@option_show_scene_when_tab_selected=(option_value=="true") ? true : false if option_name=="option_show_scene_when_tab_selected"
					@option_check_for_updates=(option_value=="true") ? true : false if option_name=="option_check_for_updates"
					@option_dblclick_for_link=(option_value=="true") ? true : false if option_name=="option_dblclick_for_link"
					@option_ctrl_for_link=(option_value=="true") ? true : false if option_name=="option_ctrl_for_link"
					@option_usage=option_value.to_i if option_name=="option_usage"
				end
				file.close
			else												#File doesn't exist
				#Save Default options
				save_options
			end
		end
		def self.load_default_options	#Default options
			@option_langue=Sketchup.os_language
			@option_open_window = false
			@option_open_window_if_exist = true
			@option_show_bottom = true
			@option_close_calc = false
			@option_show_scene_when_tab_selected = true
			@option_check_for_updates=true
			@option_dblclick_for_link=false
			@option_ctrl_for_link=true
			@option_usage=0
		end
		def self.load_options_in_html	#Tick options
			cb=[]
			cb.push (@option_open_window_if_exist==true) ? "true" : "false"
			cb.push (@option_open_window==true) ? "true" : "false"
			cb.push (@option_show_bottom==true) ? "true" : "false"
			cb.push (@option_close_calc==true) ? "true" : "false"
			cb.push (@option_show_scene_when_tab_selected==true) ? "true" : "false"
			cb.push (@option_check_for_updates==true) ? "true" : "false"
			cb.push (@option_dblclick_for_link==true) ? "true" : "false"
			cb.push (@option_ctrl_for_link==true) ? "true" : "false"
			
			js = "bgSketchup_error='load_options_in_html';"
			for i in 0..cb.length-1
				js+= "document.getElementById('cb"+i.to_s+"').checked="+cb[i].to_s+";"
			end
			js+="document.getElementById('languagelist').value='"+@option_langue.to_s+"';"
			bgSketchup_execute_script(@my_dialog,js)
			
			# Hyperlink management
				if @option_dblclick_for_link==true then
					js="editor.on('instanceReady', function(ev) { $('iframe').contents().dblclick(function(e) {"
				else
					js="editor.on('instanceReady', function(ev) { $('iframe').contents().click(function(e) {"
				end
				if @option_ctrl_for_link==true then
					js+="if(typeof e.target.href != 'undefined' && e.ctrlKey == true) { window.open(e.target.href, 'new' + e.screenX); } }); });"
				else
					js+="if(typeof e.target.href != 'undefined'){window.open(e.target.href, 'new' + e.screenX); } }); });"
				end
				bgSketchup_execute_script(@my_dialog,js)
		end
		def self.appliquerOptions(options)
			old=@option_langue
			old_option_dblclick_for_link=@option_dblclick_for_link
			old_option_ctrl_for_link=@option_ctrl_for_link
			@option_open_window_if_exist=(options[0].chr=='1') ? true : false
			@option_open_window=(options[1].chr=='1') ? true : false
			@option_show_bottom=(options[2].chr=='1') ? true : false
			@option_close_calc=(options[3].chr=='1') ? true : false
			@option_show_scene_when_tab_selected=(options[4].chr=='1') ? true : false
			@option_check_for_updates=(options[5].chr=='1') ? true : false
			@option_dblclick_for_link=(options[6].chr=='1') ? true : false
			@option_ctrl_for_link=(options[7].chr=='1') ? true : false
			o=options[9..options.length-1].split(",")
			@option_langue=o[0]
			self.save_options
			if (@option_langue!=old) || (old_option_dblclick_for_link!=@option_dblclick_for_link) || (old_option_ctrl_for_link!=@option_ctrl_for_link) then	
				#Si on change de langue ou les options pour les vnements, alors on redmarre l'interface
				@my_dialog.close();@my_dialog=nil
				initialise_localization
				self.show_hide_Comments_window
			end
		end
		
		# UPDATES
		def self.check_for_updates(kind_of_control) #kind_of_control='prompt' or 'check'
			bgSketchup_execute_script(@my_dialog,"check_version('"+BGSketchup_Comments_extension.version+"','"+kind_of_control+"');")
		end
		def self.prompt_update_check(result,news)
			news.gsub!("<br>","\n")
			case result # this is the result of the html page
				when "NA" #No connection
					UI.messagebox @strNotConnectedToInternet
				when "different"
					UI.messagebox @strVersionDifferent+"\n\n"+@strVersionUpdates+"\n"+news
				when "equal"
					UI.messagebox @strVersionUpToDate
			end
		end
		
		#STATISTIQUES
		def self.stats_incrementer_compteur
			#On envoie les donnes
			bgSketchup_add_stats(@my_dialog, BGSketchup_Comments_extension, [bgSketchup_Temp_folder_is_plugin_folder?,@option_usage.to_s])
		end
		
		# OBSERVERS
		def self.attach_observers
			Sketchup.add_observer(Comments::MyAppObserver.new)
			Sketchup.active_model.add_observer(Comments::MyModelObserver.new)
			id = Sketchup::Pages.add_frame_change_observer(FrameChangeObserver.new)
		end
		class FrameChangeObserver 						# Class to manage tab modification
			def initialize
				@current_page = Sketchup.active_model.pages.selected_page 
			end
			def frameChange(fromPage, toPage, percent_done) 
				# If there has been a page change and it has completed 
				if (not toPage.nil? and percent_done == 0) then 
					 if @current_page != toPage then 
						#update the current page 
							@current_page = toPage
						#Get modified page name
							name=@current_page.name.to_s
						#Find if the tab is under control
							attrdict = Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments']
							if attrdict!=nil then
								max=0
								attrdict.each_key { | key |
									if key[0..3]="Text" then
										if key!="Text" then					
											ind=key[4..key.length-1].to_i
											if (ind>max) then
												max = ind
											end
										end
									end
								}
								for tab in 0..max
									tab2=tab; tab2='' if tab==0
									t=Sketchup.active_model.get_attribute "BGSketchup_Comments", "TabScene"+tab2.to_s, ""
									if t==name then #We've got it
										Comments::show_tab(tab)
									end
								end
							end
					 end 
				end 
			end 
		end
		class MyAppObserver < Sketchup::AppObserver		# Observer Class for new and open model
			def onNewModel(model)
				Comments::start
				Sketchup.active_model.add_observer(Comments::MyModelObserver.new)
			end
			def onOpenModel(model)
				Comments::start
				Sketchup.active_model.add_observer(Comments::MyModelObserver.new)
			end
		end
		class MyModelObserver < Sketchup::ModelObserver	# Observer Class for saving comment when saving the model
			def onPreSaveModel(model)
				if ((Sketchup.active_model.get_attribute "BGSketchup_Comments", "CommentsToBeSave","")=="true") then
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "CommentsToBeSave","false"
					Comments::save_comments
				end
				Comments::save_current_tab
				
			end
		end
		
		unless file_loaded?( __FILE__ )
			initialise_localization(false)
			if !File.exists?(File.join(File.dirname(__FILE__), "..", 'BGSketchup_Library.rb')) then
				reponse=UI.messagebox(@translation_library_no_found+@translation_open_link,MB_YESNO)
				if reponse==IDYES then
					status = UI.openURL("http://sketchucation.com/pluginstore?pln=BGSketchup_Library")
				end
			else
				Sketchup::require 'BGSketchup_Library'
				extend BGSketchup_Library
				if bgSketchup_version_library>=Required_library_version then
					self.load_options
					initialise_localization(false)
					self.creation_menus
					self.creation_toolbar
					self.load_comments(0)
					if File.exists?(File.join(bgSketchup_getTempFolder,"Debug.bg"))
						Sketchup.send_action(CMD_RUBY_CONSOLE) 
						#self.show_hide_window
					end
				else
					self.load_options
					initialise_localization(false)
					txt=@translation_library_not_good_version+10.chr
					txt+="(Required : "+bgSketchup_version_library_string(Required_library_version)+", current : "+bgSketchup_version_library_string(nil)+")"+10.chr
					txt+=@translation_open_link
					reponse=UI.messagebox(txt,MB_YESNO)
					if reponse==IDYES then
						bgSketchup_update_manager
					end
				end
			end
		end
		file_loaded(__FILE__)
	end #module Comments
	Comments.new
end #module BGSketchup
