# Localization file for BGSketchup_Comments plugin

module BGSketchup_Comments
	def initialise_localization(prompt=true)
		@availableLanguages=["en","fr","pt","pt-br","es","ru","zh-CN","zh-TW"]
		@availableLanguagesName=["English","Français","Português","Português Brasileiro","Español","Russian","简中","繁中"]
		@option_langue="en" if @availableLanguages.index(@option_langue)==nil	
		
		# Load default text in English in case a translation is missing
			@strWindowName="Comments"
			@strButtonsTitles=["Add current date and time", 
				"Calculator", 
				"Options", 
				"About", 
				"Close calculator", 
				"Insert result in current tab", 
				"Insert result in current tab with formula",
				"Check for plugin update"]
			@strModifyTabName="Tab options"
			@strDeleteTab="Delete the tab"
			@strButtonsTexts=["Save","Cancel"]
			@strAbout="About"
			@strTexts=["Language", 
				"Auto-open window if comments exist",
				"Auto-open window even if comment doesn't exist",
				"Show bottom of the text area at launch",
				"Close calculator after inserting result",
				"Show scene when tab is linked",
				"Check for update on startup",
				"Double click to open a hyperlink",
				"Ctrl key must be pressed to open a hyperlink"]
			@strTabName="Enter tab's name : "
			@strTab="Tab "
			@strSureToDeleteTab = "Are you sure to delete this tab ?"
			@strTabOptionName="Tab options"
			@strNoLink="-- Not linked --"
			@strTextsOptionsTab=["Tab name :","Linked scene :","Apply","Cancel","Tab color :"]
			@strNotConnectedToInternet="Impossible to connect to the Internet. Please connect to the Web, close plugin and re-start."
			@strVersionDifferent="A newer version of plugin 'Comments' is avalaible !"
			@strVersionUpToDate="Your version is up to date."
			@strVersionUpdates="Improvments of this version :"
			@strLinkSketchUcation="Click here to go to SketchUcation.com"
			@strLegends=["General","Editor","Calculator","Other"]
			
			@translation_library_no_found="Error, BGSketchup_Library extension not found. Please download it from store."
			@translation_library_not_good_version="The extension BGSketchup Library version is too old, please download the latest version on sketchUcation.com"
			@translation_open_link="Do you want to open link to download it ?"

				
		if @option_langue=="fr" then
			@strWindowName="Commentaires"
			@strButtonsTitles=["Ajouter la date et l'heure actuelle", 
				"Calculatrice", 
				"Options", 
				"A propos", 
				"Ferme la calulatrice", 
				"Insère le résultat dans l'onglet actuel",
				"Insère le résultat dans l'onglet actuel avec la formule",
				"Vérifier les mises à jour"]
			@strModifyTabName="Options de l'onglet"
			@strDeleteTab="Supprimer l'onglet"
			@strButtonsTexts=["Enregistrer","Annuler"]
			@strAbout="A propos"
			@strTexts=["Langue", 
				"Ouvrir automatiquement si un commentaire existe",
				"Ouvrir automatiquement même si un commentaire n'existe pas",
				"Montrer la fin du texte à l'ouverture",
				"Fermer la calculatrice après insertion du résultat",
				"Montrer la scène quand un onglet est lié",
				"Vérifier les mises à jour au démarrage",
				"Double click pour ouvrir un lien hyperlien",
				"La touche 'ctrl' doit être appuyée pour ouvrir un lien hyperlien"]
			@strTabName="Entrez le nom de l'onglet : "
			@strTab="Onglet "
			@strSureToDeleteTab = "Etes-vous sûr de vouloir supprimer cet onglet ?"
			@strTabOptionName="Options de l'onglet"
			@strNoLink="-- Pas de lien --"
			@strTextsOptionsTab=["Nom de l'onglet :","Scène liée :","Appliquer","Annuler","Couleur de l'onglet :"]
			@strNotConnectedToInternet="Impossible de se connecter à Internet. Merci de se connecter de fermer et le relancer le plugin."
			@strVersionDifferent="Une nouvelle version du plugin 'Comments' est disponible !"
			@strVersionUpToDate="Votre version est à jour."
			@strVersionUpdates="Amélioration de cette version :"
			@strLinkSketchUcation="Cliquer ici pour aller sur SketchUcation.com"				
			@strLegends=["Général","Editeur","Calculatrice","Autre"]
			
		elsif @option_langue=="es" then
			@strWindowName="Comentarios"
			@strButtonsTitles=["Añadir fecha y hora actuales", 
				"Calculadora", 
				"Opciones", 
				"Acerca de", 
				"Cerrar la calculadora", 
				"Insertar resultado en la pestaña actual",
				"Insertar resultado con la fórmula en la pestaña actual",
				"Buscar actualizaciones"]
			@strModifyTabName="Opciones de la Pestaña"
			@strDeleteTab="Eliminar la pestaña"
			@strButtonsTexts=["Guardar","Cancelar"]
			@strAbout="Acerca de"
			@strTexts=["Idioma", 
				"Auto-abrir la ventana si existen comentarios",
				"Auto-abrir la ventana incluso si no existe comentario",
				"Mostrar parte inferior del área de texto al inicio",
				"Cerrar la calculadora después de insertar resultado", 
				"Mostrar la escena cuando la pestaña está vinculada",
				"Buscar actualizaciones en el arranque", 
				"Haga doble clic para abrir un hipervínculo", 
				"Tecla Ctrl se debe presionar para abrir un hipervínculo"]
			@strTabName="Escribe el nombre de la pestaña : "
			@strTab="Pestaña "
			@strSureToDeleteTab = "¿Estás seguro que deseas eliminar esta pestaña?"
			@strTabOptionName="Opciones de la pestaña"
			@strNoLink="-- No enlazada --"
			@strTextsOptionsTab=["Nombre de la pestaña:", "Escena Enlazada:","Aplicar", "Cancelar", "Color de la pestaña:"]
			@strNotConnectedToInternet = "No se puede conectar a Internet. Por favor identifícate para cerrar y reiniciar el plugin." 
			@strVersionDifferent = "¡Una nueva versión del plugin 'Comentarios' está disponible!" 
			@strVersionUpToDate = "Tu versión está actualizada." 
			@strVersionUpdates = "Mejorar esta versión:" 
			@strLinkSketchUcation = "Haga clic aquí para ir a SketchUcation.com"
			@strLegends = ["General", "Editor", "Calculadora", "Otros"]
				
		elsif @option_langue=="pt" then
			@strWindowName="Comentários"
			@strButtonsTitles=["Adicionar data e hora atual", 
				"Calculadora", 
				"Options", 
				"Sobre", 
				"Fechar calculadora", 
				"resultado Inserir na guia atual",
				"Insira resultado na aba atual com fórmula",
				"Verifique se há atualização"]
			@strModifyTabName="Guia Opções"
			@strDeleteTab="Excluir a guia"
			@strButtonsTexts=["Salvar","Cancelar"]
			@strAbout="Sobre"
			@strTexts=["Língua", 
				"Auto-janela aberta, se existem comentários",
				"Auto-janela aberta, mesmo que comentário não existe",
				"Mostrar parte inferior da área de texto no lançamento",
				"Fechar calculadora após a inserção de resultado", 
				"Mostre cena quando o separador está ligado",
				"Verifique se há atualização na inicialização", 
				"Dê um duplo clique para abrir um hyperlink", 
				"Tecla Ctrl deve ser pressionada para abrir um hyperlink"]
			@strTabName="Digite o nome do guia : "
			@strTab="Guia "
			@strSureToDeleteTab = "Tem certeza que deseja deletar este guia?"
			@strTabOptionName="Guia Opções"
			@strNoLink="-- não ligado --"
			@strTextsOptionsTab=["Nome guia", "Amarrado Cena","Aplicar", "Cancelar", "Cor guia : "]
			@strNotConnectedToInternet = "Não foi possível conectar-se à Internet. Faça login para fechar e reiniciar o plugin." 
			@strVersionDifferent = "Uma nova versão do plug-in 'Comentários' está disponível!" 
			@strVersionUpToDate = "Sua versão é até à data." 
			@strVersionUpdates = "Melhorar a esta versão:" 
			@strLinkSketchUcation = "Clique aqui para ir para SketchUcation.com"
			@strLegends = ["Geral", "Editor", "Calculadora", "Outro"]
		
		elsif @option_langue=="pt-br" then
			@strWindowName="Comentários"
			@strButtonsTitles=["Adicionar data e hora atual", 
				"Calculadora", 
				"Opções", 
				"Sobre", 
				"Fechar calculadora", 
				"Inserir resultado na guia atual",
				"Inserir resultado na guia atual com fórmula",
				"Verifique se há atualização"]
			@strModifyTabName="Guia Opções"
			@strDeleteTab="Excluir a guia"
			@strButtonsTexts=["Salvar","Cancelar"]
			@strAbout="Sobre"
			@strTexts=["Idioma", 
				"Abrir automaticamente a janela, se existirem comentários",
				"Abrir automaticamente a janela, mesmo que não existam comentários",
				"Mostrar parte inferior da área de texto no lançamento",
				"Fechar calculadora após inserir o resultado", 
				"Mostre a cena quando a guia estiver vinculada",
				"Verifique se há atualização na inicialização", 
				"Dê um duplo clique para abrir um hyperlink", 
				"Tecla Ctrl deve ser pressionada para abrir um hyperlink"]
			@strTabName="Digite o nome da guia : "
			@strTab="Guia "
			@strSureToDeleteTab = "Tem certeza que deseja deletar esta guia?"
			@strTabOptionName="Guia Opções"
			@strNoLink="-- nenhuma cena --"
			@strTextsOptionsTab=["Nome da guia", "Amarrado à Cena","Aplicar", "Cancelar", "Cor da guia : "]
			@strNotConnectedToInternet = "Não foi possível conectar-se à Internet. Faça login para fechar e reiniciar o plugin." 
			@strVersionDifferent = "Uma nova versão do plug-in 'Comentários' está disponível!" 
			@strVersionUpToDate = "Sua versão é a mais recente." 
			@strVersionUpdates = "Melhorar esta versão:" 
			@strLinkSketchUcation = "Clique aqui para ir para SketchUcation.com"
			@strLegends = ["Geral", "Editor", "Calculadora", "Outro"]
			
		elsif @option_langue=="de" then
			@strWindowName="Kommentare"
			@strButtonsTitles=["Aktuelle Zeit und Datum hinzufügen", 
				"Rechner", 
				"Optionen", 
				"Über", 
				"Close-Rechner", 
				"Insert Ergebnis in aktuellen Registerkarte",
				"Legen Ergebnis im aktuellen Registerkarte mit Formel",
				"Nach Update"]
			@strModifyTabName="Registerkarte-Optionen"
			@strDeleteTab="Löschen Sie die Registerkarte"
			@strButtonsTexts=["Speichern","Abbrechen"]
			@strAbout="Über"
			@strTexts=["Sprache", 
				"Automatisch Fenster öffnen, wenn Kommentare vorhanden sind",
				"Automtisch Fenster öffnen, auch wenn keine Kommentare vorhanden sind",
				"Beim Start zum Textende springen",
				"Schließen-Rechner nach dem Einlegen Ergebnis",
				"Zeigen Szene, als Register verknüpft",
				"Nach Update beim Start", 
				"Ein Doppelklick auf einen Hyperlink zu öffnen", 
				"Strg-Taste gedrückt werden muss, um einen Hyperlink zu öffnen"]
			@strTabName="Geben Sie den Namen der Registerkarte : "
			@strTab="Registerkarte "
			@strSureToDeleteTab = "Sind Sie sicher, dass Sie diese Registerkarte löschen?"
			@strTabOptionName="Registerkarte-Optionen"
			@strNoLink="-- Nicht verbunden --"
			@strTextsOptionsTab=["Nennen Registerkarte :","Ähnliche Szene :","Übernehmen", "Abbrechen","Farb Registerkarte :"]
			@strNotConnectedToInternet = "Kann nicht mit dem Internet verbinden. Bitte melden Sie sich zu schließen, und starten Sie das Plugin." 
			@strVersionDifferent = "Eine neue Version von 'Kommentare' Plugin ist da!" 
			@strVersionUpToDate = "Ihre Version ist up to date." 
			@strVersionUpdates = "Verbesserung dieser Version:" 
			@strLinkSketchUcation = "Klicken Sie hier, um zu SketchUcation.com gehen"
			@strLegends = ["Allgemein", "Editor", "Rechner", "Sonstiges"]
		
		elsif @option_langue=="ru" then
			@strWindowName="Заметки"
			@strButtonsTitles=["Добавить текущую дату и время", 
				"Калькулятор", 
				"Настройки", 
				"О Плагине", 
				"Закрыть калькулятор", 
				"Вставить результат в текущей вкладке", 
				"Вставьте результат в текущей вкладке с формулой", 
				"Проверить наличие обновлений"]
			@strModifyTabName="Настройки Вкладки"
			@strDeleteTab="Удалить Вкладку"
			@strButtonsTexts=["Сохранить","Отмена"]
			@strAbout="О Плагине"
			@strTexts=["Язык", 
				"Автоматически открывать окно, если существуют заметки",
				"Автоматически открывать окно, даже если заметок нет",
				"Показывать окончание заметки при открытии вкладки", 
				"Закрыть калькулятор после вставки результат", 
				"Показать сцену, когда вкладка связана",
				"Проверить наличие обновлений при запуске", 
				"Дважды щелкните, чтобы открыть гиперссылку", 
				"Ключ Ctrl необходимо нажать, чтобы открыть гиперссылку"]
			@strTabName="Название Заметки: "
			@strTab=""
			@strSureToDeleteTab = "Вы уверены, что хотите УДАЛИТЬ эту вкладку?"
			@strTabOptionName="Настройки вкладки"
			@strNoLink="-- Не связывать со Сценой --"
			@strTextsOptionsTab=["Имя Вкладки :","Связка со Сценой :","Применить","Отмена", "Цвет вкладки :"]
			@strNotConnectedToInternet = "Невозможно подключиться к Интернету. Пожалуйста, войдите, чтобы закрыть и перезапустить плагин." 
			@strVersionDifferent = "Новая версия плагина  'Комментарии' уже в продаже!" 
			@strVersionUpToDate = "Ваша версия находится в актуальном состоянии." 
			@strVersionUpdates = "Улучшение эту версию:" 
			@strLinkSketchUcation = "Щелкните здесь, чтобы перейти к SketchUcation.com"
			@strLegends = ["Общие", "Редактор", "Калькулятор", "Другие"]
		
		elsif @option_langue=="zh-CN" then
			@strWindowName="注释"
			@strButtonsTitles=["添加當前日期和時間", 
				"計算机", 
				"选项", 
				"关于", 
				"关闭计算机", 
				"插入在当前标签的结果", 
				"插入在当前标签的结果与公式",
				"检查插件更新"]
			@strModifyTabName="标签的选项"
			@strDeleteTab="删除标签"
			@strButtonsTexts=["保存","取消"]
			@strAbout="关于"
			@strTexts=["語言", 
				"自动打开的窗口，即使注釋存在",
				"自动打开的窗口，即使注釋不存在",
				"在窗口底部区域显示文本",
				"插入后的结果接近计算机",
				"显示选项卡连接时的场景",
				"在启动时检查更新",
				"双击打开一个链接",
				"按Ctrl键必须按下打开超链接"]
			@strTabName="输入标签的名称 : "
			@strTab="标签 "
			@strSureToDeleteTab = "您确定要删除这个标签?"
			@strTabOptionName="标签的选项"
			@strNoLink="-- 没有连接 --"
			@strTextsOptionsTab=["标签名称 :","连接场景 :","应用","取消","标签颜色 :"]
			@strNotConnectedToInternet="无法连接到Internet。请连接到网络，关闭和重新启动插件。"
			@strVersionDifferent="“注釋”已有了一个新版本的插件！"
			@strVersionUpToDate="您的版本是最新的."
			@strVersionUpdates="这个版本的改进 :"
			@strLinkSketchUcation="点击这里去sketchucation.com"
			@strLegends=["一般","編輯"," 計算机","其它"]
			@translation_library_no_found="错误，没有发现BGSketchup_Library 扩展库。请从商店下载它。"
			@translation_library_not_good_version="BGSketchup扩展库的版本太旧，请在sketchucation.com下载最新版本"
			@translation_open_link="你想打开链接下载吗？"
			
		elsif @option_langue=="zh-TW" then
			@strWindowName="註釋"
			@strButtonsTitles=["添加當前日期和時間", 
				"計算機", 
				"選項", 
				"關於", 
				"關閉計算機", 
				"插入在當前標籤的結果", 
				"插入在當前標籤的結果與公式",
				"檢查外掛程式更新"]
			@strModifyTabName="標籤的選項"
			@strDeleteTab="刪除標籤"
			@strButtonsTexts=["保存","取消"]
			@strAbout="關於"
			@strTexts=["語言", 
				"自動打開的視窗，即使注釋存在",
				"自動打開的視窗，即使注釋不存在",
				"在視窗底部區域顯示文本",
				"插入後的結果接近計算機",
				"顯示選項卡連接時的場景",
				"在啟動時檢查更新",
				"按兩下打開一個連結",
				"按Ctrl鍵+滑鼠打開超連結"]
			@strTabName="輸入標籤的名稱 : "
			@strTab="標籤 "
			@strSureToDeleteTab = "您確定要刪除這個標籤?"
			@strTabOptionName="標籤的選項"
			@strNoLink="-- 沒有連接 --"
			@strTextsOptionsTab=["標籤名稱 :","連接場景 :","應用","取消","標籤顏色 :"]
			@strNotConnectedToInternet="無法連接到Internet。請連接到網路，關閉和重新開機外掛程式。"
			@strVersionDifferent="“註釋”已有了一個新版本的外掛程式！"
			@strVersionUpToDate="您的版本是最新的."
			@strVersionUpdates="這個版本的改進 :"
			@strLinkSketchUcation="點擊這裡去sketchucation.com"
			@strLegends=["一般","編輯"," 計算機","其它"]
			@translation_library_no_found="錯誤，沒有發現BGSketchup_Library 擴展庫。請從商店下載它。"
			@translation_library_not_good_version="BGSketchup擴展庫的版本太舊，請在sketchucation.com下載最新版本"
			@translation_open_link="你想打開連結下載嗎？"
		end
	end
end